{
    Файл является частью библиотеки RubiRobotLib

    © 2017-2021 Слинкин Д.А.

    Базовый модуль библиотеки.
    Базовый класс, функции инициализации-завершения

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

{$I uev3defines.inc}
unit uev3;

interface
 uses cthreads,variants,unix,types;

 {$I uev3const.inc}
 {$I uev3utf8.inc}
 {$I uev3convert.inc}
 {$I uev3sysfs.inc}
 {$I uev3devices.inc}
 {$I uev3comm.inc}

 {
  желтые огни при старте rr-программы, индикация ожидания миганием
 }
 var LedsOnStartup:boolean=true;

 {
  завершение работы долгим нажатием кнопки BACK
 }
 var KillOnBack:boolean=true;

// возможные статусы rr-Программы в коммуникациях с другими rr-Программами
 type TRRStatus=(rrHero,rrPatrial,rrHostile);
      TRRStatuses=set of TRRStatus;
 const rrStatus:array[TRRStatus]of string[30]=('Герой','Гражданин','Злодей');

{
 статус rr-Программы в коммуникациях с другими rr-Программами
 по умолчанию - Герой
 defaultStatus можно изменить до запуска ev3Init
}
 var defaultSelfStatus:TRRStatus=rrHero;

{
 rrProcess - генератор реакции rr-Программы по умолчанию
 rr-программа-Герой при запуске уничтожает все другие rr-программы-Герои
 rr-программа-Герой при запуске посылает rr-программам-Гражданам сигнал SIGUSR1
 rr-программа-Гражданин при запуске посылает rr-программам-Гражданам сигнал SIGUSR2
 rr-программа-Гражданин при запуске посылает rr-программам-Героям сигнал SIGUSR1
 defaultRRProcess можно изменить до запуска ev3Init

 pid - сторонний процесс
 pidStatus - статус, выставленный сторонним процессом для других
 selfStatus - статус, который выставляется текущим процессом

}
 procedure rrAction(pid:cint; pidStatus,selfStatus:TRRStatus);
 type TPidProcess=procedure(pid:cint; pidStatus,selfStatus:TRRStatus);
 var defaultRRAction:TPidProcess=@rrAction;

 {
  Коммуникационная процедура. Инициирует коммуникацию между rr-Программами.
  Вызывается в начале ev3Init с параметрами defaultStatus, defaultRRProcess и selfCreate=true
  selfCreate определяет, будет-ли создаваться коммуникационный токен для текущего
  процесса.
 }
 procedure rrProcessing(selfStatus:TRRStatus; ppAction:TPidProcess; selfCreate:boolean=true);


// звуковые сигналы, которые могут использоваться в ev3init()
 const signal1='-f 500 -l 100 -n -f 600 -l 100 -n -f 1500 -l 100 -n -f 1000 -l 100';
       signal2='-f 1000 -l 100 -n -f 1500 -l 100 -n -f 600 -l 100 -n -f 500 -l 100';
       signal3='-f523.251 -l100 -D100 -n -f391.995 -l100 -D100 -n -f329.628 -l100 -D100 -n -f261.626 -l200';
       signal4='-f261.626 -l200 -n -f329.628 -l100 -D100 -n -f391.995 -l100 -D100 -n -f523.251 -l100 -D100';
       signal5='-f165.4064 -l100 -n -f130.813 -l100 -n -f261.626 -l100 -n -f523.251 -l100 -n -f1046.50 -l100 -n -f2093.00  -l100 -n  -f4186.01 -l100';

var
 // ms - время слипа в режиме ожидания события
 waitInterval:word=10;

type
  TEv3EventLink=(evAND,evOR);
  TEv3Mutex=TRTLCriticalSection;
  { TEv3 }

  TEv3=class
   private
    ftimers:array[0..9]of TDateTime;
    fmutex:array[0..9]of TEv3Mutex;
   protected
    class function varToYes(yes:variant):boolean;
    {
     метод ожидания (блокировки) возникновения некоторого события
     возвращает истину при достижении события и ложь при достижения таймаута
     таймаут - в миллисекундах, при таймауте=0 - однократная проверка достижения
     В классе TEv3 - заглушка, должен перекрываться в потомках, которые нуждаются в
     механизмах ожидания событий
    }
    function waitEvent(event:ansistring; timeout:dword=high(dword)):boolean; virtual; // abstract;
    {
     метод ожидания возникновения событий на ВСЕХ переданых переданных объектах
     Параметры передаются парами: объект-событие
    }
    function waitAllEvents(objs:array of const; timeout:dword=high(dword)):boolean;
    {
     метод ожидания возникновения события на ХОТЯ-БЫ НА ОДНОМ ИЗ переданных объектов
     Параметры передаются парами: объект-событие
     Если событие возникло, возвращает первый объект, где оно возникло, иначе nil
    }
    function waitAnyEvent(objs:array of const; timeout:dword=high(dword)):TEv3;
    {
     универсальное ожидание
    }
    function waitEvents(Args:array of const; eLink:TEv3EventLink; out res:TEv3; timeout:dword=high(dword)):boolean;
    function waitEvents(Objs: array of TEv3; Events: array of string;
      eLink: TEv3EventLink; out res: TEv3; timeout: dword=high(dword)): boolean;
    {
     запускает таймер, количество таймеров - 10, с 0 до 9
     по умолчанию используется таймер с номером 0
     Таймеры с 6 по 9 задействованы системой,
     таймеры с 0 по 5 предназначены для пользователей
     с v0.2.5 можно использовать свой собственный таймер, введен
     для предотвращения гонок в параллельном исполнении
    }
    procedure _timerStart(ID:integer=0);
    procedure _timerStart(out ID:double); // собственный таймер
    {
     возвращает кол-во миллисекунд с момента запуска таймера
    }
    function _timer(ID:integer):dword;
    function _timer(ID:double):dword;
    {
     блокирует на таймаут ms с момента старта таймера
     например: timerStart(8) выполнен в 13:05:23
     если timerWait(6000,8) запущен в 13:05:25,
     то блокировка по 8 таймеру закончится 13:05:29
     если timerWait(6000,8) запущен после 13:05:29,
     то произойдет немедленный выход из функции.
    }
    procedure _timerWait(ms:dword; ID:integer);
    procedure _timerWait(ms:dword; ID:double);
    // v0.2.5
    // Обнуляет таймер на 1970 год
    procedure _timerClear(ID:integer);
    procedure _timerClear(out ID:double);
    // функции блокировки
    // Мьютексы с 6 по 9 задействованы системой,
    // Мьютексы с 0 по 5 предназначены для пользователей
    procedure _lock(ID:integer);
    procedure _unlock(ID:integer);
    function _tryLock(ID:integer):boolean;

    procedure _initMutex(var Mutex:TEv3Mutex);
    procedure _doneMutex(var Mutex:TEv3Mutex);
    procedure _lock(var Mutex:TEv3Mutex);
    procedure _unlock(var Mutex:TEv3Mutex);
    function _tryLock(var Mutex:TEv3Mutex):boolean;

   public
    constructor Create;
    {
     c v0.2
     блокирует на ms миллисекунд
    }
    procedure sleep(ms:dword);
    {
     Запускает таймер, количество таймеров - 6, с 0 до 5,
     по умолчанию используется таймер с номером 0.
     С v0.2.5 можно использовать свой собственный таймер (ID:double),
     введен для предотвращения гонок в параллельном исполнении.
    }
    procedure timerStart(ID:integer=0);
    procedure timerStart(out ID:double); // собственный таймер
    // возвращает кол-во миллисекунд с момента запуска таймера
    function timer(ID:integer=0):dword;
    function timer(ID:double):dword;
    {
     блокирует на таймаут ms с момента старта таймера
     например: timerStart(5) выполнен в 13:05:23
     если timerWait(6000,5) запущен в 13:05:25,
     то блокировка по 5 таймеру закончится 13:05:29
     если timerWait(6000,5) запущен после 13:05:29,
     то произойдет немедленный выход из функции.
    }
    procedure timerWait(ms:dword; ID:integer=0);
    procedure timerWait(ms:dword; ID:double);
    // v0.2.5
    // Обнуляет таймер на 1970 год
    procedure timerClear(ID:integer=0);
    procedure timerClear(out ID:double);

    // функции блокировки, 6 мьютексов - с 0 до 5
    procedure lock(ID:integer=0);
    procedure unlock(ID:integer=0);
    function tryLock(ID:integer=0):boolean;
    // возможность использовать собственные мьютексы
    procedure initMutext(var Mutex:TEv3Mutex);
    procedure doneMutex(var Mutex:TEv3Mutex);
    procedure lock(var Mutex:TEv3Mutex);
    procedure unlock(var Mutex:TEv3Mutex);
    function tryLock(var Mutex:TEv3Mutex):boolean;
  end;

var ev3:TEv3=nil;
  // вызов инициализции всех модулей.
  // перехват сигналов завершения работы (INT, ABRT, QUIT) с вызовом ev3Done
  procedure ev3Init();
  procedure ev3Init(links:array of const);
  procedure ev3Init(signal:string);
  procedure ev3Init(signal:string; links:array of const);

type
  TInitProc=procedure;
  TDoneProc=procedure;
  // модуль, желающий инициализации, должен вызвать pushInit
  procedure PushInit(proc:tinitproc);
  // модуль, желающий инициализации, должен вызвать pushDone
  procedure PushDone(proc:tdoneproc);

var ev3finalized:boolean=false; // истина, если сейчас идет завершение работы

    FirstInit:TInitProc=nil;
    FirstDone:TDoneProc=nil;
    LastInit:TInitProc=nil;
    LastDone:TDoneProc=nil;

procedure ev3Done;

resourceString
  ev3eTimerID='You may use only timers 0-5. Current timerID=';
  ev3eMutexID='You may use only locks 0-5. Current lockID=';



implementation


uses
  cwstring,SysUtils,BaseUnix,dateutils,uev3func,uev3devices
  {$ifdef ev3ButtonsUse},rubiroButtons{$endif}
  {$ifdef ev3LedsUse},rubiroLeds{$endif}
  {$ifdef ev3DisplayUse},rubiroScreen{$endif}
  {$ifdef ev3SoundUse},rubiroSound{$endif}
  ;

__WARNGLOBALOFF

 {$I uev3utf8.imp.inc}
 {$I uev3convert.imp.inc}
 {$I uev3comm.imp.inc}


var systemEHandler:TExceptProc;
procedure ev3EHandler(Obj: TObject; Addr: Pointer; FrameCount: LongInt; Frame: PPointer);
begin
  fpsystem('beep -f 300 -n -f 100 -n -f 200');
  if assigned(systemEHandler) then systemEHandler(Obj,Addr,FrameCount,Frame);
end;

var iProcs:array[0..500] of TInitProc;
    iCount:integer=0;
    dProcs:array[0..500] of TDoneProc;
    dCount:integer=0;


type TThreadRec=record
      stop:boolean;
     end;

var killCount:integer=0;
    killTR:TThreadRec;
    killThread:TThreadID;

function killBack(p:pointer):ptrint;
begin
 result:=0;
 while killcount<10 do begin
  if TThreadRec(p^).stop then exit;
  {$ifdef ev3ButtonsUse}
  if ev3buttons.Back then inc(killcount)
  else killcount:=0;
  {$endif}
  sleep(100);
 end;
 fpkill(fpgetpid(), SIGINT);
end;


procedure ev3Done;
 var i:integer;
begin
 killTR.stop:=true;
// writeln('term1');
 if killthread<>0 then WaitForThreadTerminate(killThread,0);
// writeln('term2');
 if ev3Finalized then exit;
 ev3Finalized:=true;
 try
  if assigned(firstDone) then firstDone();
  for i:=dCount-1 downto 0 do begin
    dprocs[i]();
 //   WD(ptruint(@dprocs[i]));
  end;
  if assigned(LastDone) then LastDone();
 except
 end;
 ev3.free;
end;

Procedure Finish(sig : cint);cdecl;
begin
 // writeln('Выход по сигналу ',sig);
 //ev3sound.beep(100);
 ev3Done();
 fpkill(fpgetpid(), sig);
end;


Procedure rrHandler(sig : cint);cdecl;
begin
 case sig of
  SIGUSR1:begin
   // общение героев с гражданами
   exit;
  end;
  SIGUSR2:begin
   // общение граждан с гражданами
   exit;
  end;
  // других вариантов нет, герои с героями не общаются,
  // герой должен остаться только один!
 end;
end;



//-----------------------------------------------------------------------------
//    rr-Коммуникации

function usedPidFile(pidFile:ansistring; var pid:cint):boolean;
Var fdDir:ansistring; pidInfo : TSearchRec;
begin
  result:=false;
  try
    pid:=strtoint(copy(pidFile,pos('.',pidFile)+1,length(pidFile)));
  except
    exit;
  end;
  fdDir:='/proc/'+inttostr(pid)+'/fd/';
  If FindFirst (fdDir+'*',faAnyFile,pidInfo)=0 then begin
    try
     Repeat
      if pidFile = extractFileName(fpReadLink(fdDir+pidinfo.name)) then begin
       result:=true;
       break;
      end;
     Until FindNext(pidinfo)<>0;
    finally
     FindClose(pidInfo);
    end;
   end;
end;

procedure rrProcessing(selfStatus:TRRStatus; ppAction:TPidProcess; selfCreate:boolean=true);
var f:text; s:string;
    baseDir:string;
    rrDir:string='.ev3rr/';
    rrDirFull:string;
    rrFile:string='ev3rr';
    rrFileFull:string;
    Info : TSearchRec;
    pid:cint;
    used:boolean;
    pidFile:text;
    rrSt:TRRStatus;
begin
 pid:=0;
 baseDir:=getTempDir(false);
 rrDirFull:=baseDir+rrDir;
 rrFileFull:=rrDirFull+rrFile+'.'+inttostr(fpgetpid);
 //создаем каталог временных файлов
 fpmkdir(rrDirFull,&0700);
 // удаляем возможно сохранившийся файл с убитых ранее процессов
 // и создаем свой pid-файл
 if selfCreate then begin
  assign(pidFile,rrFileFull);
  rewrite(pidFile); writeln(pidFile,rrStatus[selfStatus]); flush(pidFile);
  // Файл НЕ ЗАКРЫВАЕТСЯ ДО КОНЦА РАБОТЫ ПРИЛОЖЕНИЯ !!!
 end;
 // теперь смотрим файлы других процессов, проверяя их на непотерю связи
 // с родным процессом
 If FindFirst (rrDirFull+rrFile+'*',faAnyFile,Info)=0 then begin
  try
   Repeat
    used:=usedPidFile(info.name,pid);
    if used then begin
     if fpgetpid<>pid then begin
      assign(f,rrDirFull+info.name);
      reset(f); readln(f,s); close(f);
      if s=rrStatus[rrHero] then rrSt:=rrHero
      else rrSt:=rrPatrial;
      ppAction(pid,rrSt,selfStatus);
     end;
    end
    else begin
     // процесс отсутствует, а файл остался, уничтожаем
     deletefile(rrDirFull+info.name);
    end;
   Until FindNext(info)<>0;
  finally
   FindClose(Info);
  end;
 end;
end;

procedure rrAction(pid:cint; pidStatus,selfStatus:TRRStatus);
begin
 case selfStatus of
  rrHero:
	case pidStatus of
	 rrPatrial: fpkill(pid,SIGUSR1); // солдат ребенка не обидит ;)
	 rrHero: fpkill(pid,SIGINT); // герой должен быть только один
	end;

  rrPatrial:
	case pidStatus of
	 rrPatrial: fpkill(pid,SIGUSR2); // приветствую, уважаемый!
	 rrHero: fpkill(pid,SIGUSR1); // Слава защитникам!
	end;
  rrHostile: fpkill(pid,SIGINT); // Злодей - всем ВРАГ!
 end;
end;


//----------------------------------------
{
 Процедура привязки устройств к портам.
 В случае неверного определения устройства на соответствующем порту
 пытается принудительно его установить//, если Ignore=false (по умолчанию)
}
function ev3Link(port:tEv3Port; typedev:TEv3DeviceType):boolean;
  var dev:TEv3Device;
      fd:TEv3DeviceFactory;
 begin
  result:=true;
   fd:=ev3deviceFactory;
   dev:=fd.Devices[port];
   if assigned(dev) and (dev.connected) and (dev.Device=typedev) then exit; // нормально
   result:=false;
 end;



procedure ev3Init(links:array of const);
 var i:longint; errors,ecount:integer; eports:string;
     ports:array[1..8] of TEv3Port;
     devts:array[1..8] of TEv3DeviceType;
     devt:TEv3DeviceType;
     port:tEv3Port;
     devp:TEv3Device; // устройство - порт
begin
  ev3init;
//  writeln('postinit');
  eports:='';
  i:=0; errors:=0;
  while i<=High(links) do begin
    port:=TEv3DeviceHelper.varToPort(arg2string(links[i]));
    devt:=TEv3DeviceHelper.varToDevice(arg2string(links[i+1]));
    if not ev3link(port,devt) then begin
      inc(errors);
      devts[errors]:=devt;
      ports[errors]:=port;
      eports+=' '+inttostr(ord(port));
    end;
    inc(i,2);
  end;
  if errors=0 then exit;
  // ошибки найдены, исправляем
  doneDeviceFactory;
  for i:=1 to errors do begin
   devt:=devts[i];
   devp:=ev3PortFactory.devices[ports[i]];
   if ev3IDS[devt].PortMode<>'' then devp.Attrs[ev3amode].hardPutData(ev3IDS[devt].PortMode);
   if ev3IDS[devt].PortSetDevice<>'' then devp.Attrs[ev3aset_device].hardPutData(ev3IDS[devt].PortSetDevice);
  end;
{$IFDEF ev3DisplayUse}
  ev3screen.clear
           .fontSize(10)
           .print(0,20,'Ошибка устройств!')
           .print(0,40,'Порт(ы): '+eports)
           .print(0,60,'Пытаюсь исправить ...')
           .show;
{$ELSE}
  writeln(stderr,'DEVICE ERROR!');
  writeln(stderr,'Ports: ',eports);
  writeln(stderr,'Attempt to Fix ... ');
{$ENDIF}
 // ждем подьема девайсов, пищим
 while true do begin
{$IFDEF ev3SoundUse}
   ev3sound.beep(3000).wait;
{$ELSE}
  fpsystem('beep -l 3000');
{$ENDIF}
  initDeviceFactory;
  ecount:=0;
  for i:=1 to errors do if not ev3link(ports[i],devts[i]) then inc(ecount);
  if ecount=0 then break;
  doneDeviceFactory;
 end;
end;

procedure ev3Init(signal: string);
begin
  ev3init();
  startProcess('beep '+signal);
end;

procedure ev3Init(signal: string; links: array of const);
begin
 ev3Init(links);
 startProcess('beep '+signal);
end;


Var
   na,usra : SigActionRec;

procedure ev3Init;
 var i:integer;
begin
 systemEHandler:=ExceptProc;
 ExceptProc:=@ev3EHandler;

 na.sa_Handler:=SigActionHandler(@Finish);
 fillchar(na.Sa_Mask,sizeof(na.sa_mask),#0);
 na.Sa_Flags:=SA_RESETHAND;
 na.Sa_Restorer:=Nil;
 fpSigAction(SIGINT,@na,nil);
 fpSigAction(SIGABRT,@na,nil);
 fpSigAction(SIGQUIT,@na,nil);
 fpSigAction(SIGTERM,@na,nil);
 fpSigAction(SIGHUP,@na,nil);
 fpSigAction(SIGUSR1,@na,nil);
 fpSigAction(SIGUSR2,@na,nil);

 usra.sa_Handler:=SigActionHandler(@rrHandler);
 fillchar(usra.Sa_Mask,sizeof(usra.sa_mask),#0);
 usra.Sa_Flags:=0;
 usra.Sa_Restorer:=Nil;
 fpSigAction(SIGUSR1,@usra,nil);
 fpSigAction(SIGUSR2,@usra,nil);

 rrProcessing(defaultSelfStatus, defaultRRAction, true);

 // writeln(iCount);

 ev3:=TEv3.Create;
 if assigned(FirstInit) then FirstInit();
 for i:=0 to iCount-1 do begin
  iprocs[i]();
//  writeln('postinit');
 end;
 if assigned(LastInit) then LastInit();
 if killOnBack then killThread:=BeginThread(@killBack,@killTR)
 else killThread:=0;
end;


procedure PushInit(proc: tinitproc);
begin
  iprocs[icount]:=proc;
  inc(icount);
end;

procedure PushDone(proc: tdoneproc);
begin
  dprocs[dCount]:=proc;
  inc(dCount);
end;

{ TEv3 }

function TEv3.waitEvents(Args: array of const; eLink: TEv3EventLink; out res:TEv3; timeout: dword=high(dword)): boolean;
 var o:array of TEv3=nil; e:array of string=nil;
     i,k:integer;
     R:TEv3;
begin
  res:=nil;
  if High(Args)<2 then exit(false);
  setlength(o,(High(Args)+1) div 2);
  setlength(e,(High(Args)+1) div 2);
  i:=0;k:=0;
  while i<High(Args) do begin
    o[k]:=arg2Obj(args[i]) as TEv3;
    e[k]:=arg2String(args[i+1]);
    //writeln(o[i].classname,' - ',arg2String(args[i+1]));
    inc(i,2);
    inc(k);
  end;
//  for i:=0 to length(e)-1 do writeln(o[i].classname,' + ',e[i]);
  result:=self.waitEvents(o,e,elink,R,timeout);
  res:=R;
end;

function TEv3.waitEvents(Objs: array of TEv3; Events: array of string;
  eLink: TEv3EventLink; out res: TEv3; timeout: dword=high(dword)): boolean;
var
    allYes,yes:boolean;
    i:integer;
    cnt:integer;
    tm:double;
begin
 cnt:=0;
 try
  _timerStart(tm);
  while true do begin
    inc(cnt); 
    if cnt>20 then begin 
     cnt:=0; 
    {$IFDEF ev3LedsUse}
     if ledsOnStartup then ev3Leds.blink; 
    {$endif}
    end;
    allYes:=true;
    for i:=0 to length(objs)-1 do begin
      yes:=objs[i].waitEvent(events[i],0);
      if (eLink=evOr) and yes then begin
       // writeln('-- ',events[i]);
        res:=objs[i];
        exit(true);
      end;
      AllYes:=AllYes and yes;
    end;
    if allyes then exit(true);
    if _timer(tm)>=timeout then exit(false);
    sleep(waitInterval);
  end;
 finally
{$IFDEF ev3LedsUse}
  if ledsOnStartup then ev3leds.unblink;
{$endif}
 end;
end;

procedure TEv3.sleep(ms: dword);
begin
  //result:=self;
  SysUtils.Sleep(ms);
end;

procedure TEv3.timerStart(ID: integer);
begin
  if (id>5)or(id<0) then
   raise Exception.Create(ev3eTimerID+toStr(ID));
  _timerStart(id);
end;

procedure TEv3.timerStart(out ID: double);
begin
 _timerStart(id);
end;

function TEv3.timer(ID: integer): dword;
begin
  if (id>5)or(id<0) then raise Exception.Create(ev3eTimerID+toStr(ID));
  result:=_timer(id);
end;

function TEv3.timer(ID: double): dword;
begin
 result:=_timer(id);
end;

procedure TEv3.timerWait(ms: dword; ID: integer);
begin
 if (id>5)or(id<0) then raise Exception.Create(ev3eTimerID+toStr(ID));
 _timerWait(ms,id);
end;

procedure TEv3.timerWait(ms: dword; ID: double);
begin
  _timerWait(ms,id);
end;

procedure TEv3.timerClear(ID: integer);
begin
  if (id>5)or(id<0) then raise Exception.Create(ev3eTimerID+toStr(ID));
  _timerClear(id);
end;

procedure TEv3.timerClear(out ID: double);
begin
 _timerClear(id);
end;

procedure TEv3.lock(ID: integer);
begin
  if (id>5)or(id<0) then raise Exception.Create(ev3eMutexID+toStr(ID));
  _lock(id);
end;

procedure TEv3.unlock(ID: integer);
begin
  if (id>5)or(id<0) then raise Exception.Create(ev3eMutexID+toStr(ID));
  _unlock(id);
end;

function TEv3.tryLock(ID: integer): boolean;
begin
  if (id>5)or(id<0) then raise Exception.Create(ev3eMutexID+toStr(ID));
  result:=_tryLock(id);
end;

procedure TEv3.initMutext(var Mutex: TEv3Mutex);
begin
 _initMutex(Mutex);
end;

procedure TEv3.doneMutex(var Mutex: TEv3Mutex);
begin
 _doneMutex(Mutex);
end;

procedure TEv3.lock(var Mutex: TEv3Mutex);
begin
  _lock(Mutex);
end;

procedure TEv3.unlock(var Mutex: TEv3Mutex);
begin
 _unlock(Mutex);
end;

function TEv3.tryLock(var Mutex: TEv3Mutex): boolean;
begin
 result:=_tryLock(Mutex);
end;

procedure TEv3._timerStart(ID: integer);
begin
 _lock(9);
 try
  _timerStart(ftimers[id]);
 finally
  _unlock(9);
 end;
end;

procedure TEv3._timerStart(out ID: double);
begin
 id:=now();
end;

function TEv3._timer(ID: integer): dword;
begin
 result:=_timer(ftimers[id]);
end;

function TEv3._timer(ID: double): dword;
begin
 result:=MilliSecondsBetween(now(),id);
end;


procedure TEv3._timerWait(ms: dword; ID: integer);
begin
 _lock(9);
 try
  _timerWait(ms,ftimers[id]);
 finally
  _unlock(9);
 end;
end;

procedure TEv3._timerWait(ms: dword; ID: double);
 var tm:dword;
begin
 tm:=_timer(id);
 if tm>ms then exit;
 sleep(ms-tm);
end;

procedure TEv3._timerClear(ID: integer);
begin
  _lock(9);
  try
   _timerClear(ftimers[id]);
  finally
   _unlock(9);
  end;
end;

procedure TEv3._timerClear(out ID: double);
begin
 id:=0.0;
end;

procedure TEv3._lock(ID: integer);
begin
 _lock(fmutex[id]);
end;

procedure TEv3._unlock(ID: integer);
begin
 _unlock(fmutex[id]);
end;

function TEv3._tryLock(ID: integer): boolean;
begin
 exit(_trylock(fmutex[id]));
end;

procedure TEv3._initMutex(var Mutex: TEv3Mutex);
begin
 InitCriticalSection(Mutex);
end;

procedure TEv3._lock(var Mutex: TEv3Mutex);
begin
 if not ev3finalized then enterCriticalSection(mutex);
end;

procedure TEv3._unlock(var Mutex: TEv3Mutex);
begin
 if not ev3finalized then LeaveCriticalSection(mutex);
end;

function TEv3._tryLock(var Mutex: TEv3Mutex): boolean;
begin
 if not ev3finalized then
  exit(boolean(tryEnterCriticalSection(mutex)))
 else
  exit(true);
end;

procedure TEv3._doneMutex(var Mutex: TEv3Mutex);
begin
  DoneCriticalsection(Mutex);
end;


constructor TEv3.Create;
 var i:integer;
begin
  inherited Create;
  for i:=low(fmutex) to high(fmutex) do begin
    _InitMutex(fmutex[i]);
  end;
  for i:=low(ftimers) to high(ftimers) do ftimers[i]:=0.0;
end;

class function TEv3.varToYes(yes: variant): boolean;
begin
 case utf8lowercase(trim(varToStr(yes))) of
  'нет','no','0','':result:=false
  else result:=true;
 end;
end;


__WARNOFFUNUSED
function TEv3.waitEvent(event: ansistring; timeout: dword): boolean;
begin
  result:=true;
  RunError(65535);
end;
__WARNON

function TEv3.waitAllEvents(objs: array of const; timeout: dword=high(dword)): boolean;
  var res:TEv3;
begin
  result:=waitEvents(objs,evAND,res,timeout);
end;

function TEv3.waitAnyEvent(objs: array of const; timeout: dword=high(dword)): TEv3;
begin
 waitEvents(objs,evOR,result,timeout);
end;


var fnOld,fnNew:string;

initialization
 // перенос файла ошибок, созданного brickman, во временный каталог
 fnOld:=paramstr(0)+'.err.log';
 fnNew:=getTempDir+extractfileName(fnOld);
 if fileexists(fnOld) then begin
  fpunlink(fnNew);
  fplink(fnOld,fnNew);
  fpunlink(fnOld);
 end;

finalization
 ev3Done();
end.

